//adac.h
//Initializes audio output, sets up timed calls of mixing function
//Bryan Topp <betopp@betopp.com> 2016

#pragma once

//Initializes the audio output.
void adac_init();

//Refills the ring buffer as needed. Call periodically.
void adac_pump();

//Set this to test audio - 0 = normal operation, 1 = left channel sine, 2 = right channel sine, 3 = both channels sine
extern unsigned char adac_testmode;

//Plays a given sound, of given length, at given left/right volumes
void adac_play(const short *data, unsigned int length_in_samples, unsigned char vol_left, unsigned char vol_right);
