//dram.h
//Functions for initializing the DRAM and loading its contents
//Bryan Topp <betopp@betopp.com> 2016

#pragma once

#ifndef JSYS_PC_MOCKUP
	
	//Real machine puts DRAMFS at 0x80 - a little ways into the physical SDRAM.
	#define DRAM_ORIGIN ((void*)(0x00))
	#define DRAMFS_LOC ((void*)(0x80))

#else //Mockup code follows

	//Mockup uses a pointer to DRAMFS, which the setup code makes
	#define DRAM_ORIGIN ((void*)(mockup_dram))
	#define DRAMFS_LOC ((void*)(mockup_dram+0x80))
	extern void* mockup_dram;

#endif //JSYS_PC_MOCKUP

//DRAM is mocked up to real size
#define DRAM_SIZE (32*1024*1024)

//One function here - should set up memory and load the necessary static content.
void dram_init();