//dramfs.h
//DRAM "filesystem" to hold graphics blobs
//Bryan Topp <betopp@betopp.com> 2015

#pragma once

#include <sys/types.h>

//Initializes the DRAMFS - verifies that data exists in DRAM.
void dramfs_init();

//Marks the DRAMFS as invalid (if you have, for example, run a destructive DRAM test)
void dramfs_clobbered();

//Returns the name of the file at index file_index.
const char *dramfs_getname(unsigned int file_index);

//Returns the contents of the file at index file_index.
const void *dramfs_getptr(unsigned int file_index);

//Returns the length of the file at index file_index.
size_t dramfs_getlen(unsigned int file_index);

//Returns the index of the file named filename, or -1 if not found.
unsigned int dramfs_findfile(const char *filename);

//Returns the number of files in DRAMFS.
unsigned int dramfs_numfiles();

//Returns 1 if the DRAMFS was loaded correctly.
unsigned int dramfs_isvalid();