//bmpbg.c
//Explodes 8-bit BMP image into raw pixel data files for rendering
//Bryan Topp <betopp@betopp.com> 2015

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>

int main(int argc, const char **argv)
{
	if(argc != 3 /*4*/ )
	{
		printf("Usage: %s <bmp> <output filename>\n" /* <output filename, alpha>\n"*/, argv[0]);
		exit(-1);
	}
	
	FILE *bmpfile = fopen(argv[1], "rb");
	assert(bmpfile);
	
	size_t bmpsize;
	fseek(bmpfile, 0, SEEK_END);
	bmpsize = ftell(bmpfile);
	fseek(bmpfile, 0, SEEK_SET);
	
	void *bmpdata = malloc(bmpsize);
	size_t bytes_read = fread(bmpdata, 1, bmpsize, bmpfile);
	assert(bytes_read == bmpsize);
	
	FILE *pxfile = fopen(argv[2], "wb");
	assert(pxfile);

//	FILE *afile = fopen(argv[3], "wb");
//	assert(afile);
	
	printf("Pixels -> %s\n", argv[2]);
//	printf("Alpha bits packed -> %s\n", argv[3]);

	unsigned int pixel_offset = *((unsigned int*)(bmpdata+0x0A));
	
	printf("Offset to pixel data is %u\n", pixel_offset);
	
	unsigned int bmp_width = *((unsigned int*)(bmpdata+0x12)); 
	unsigned int bmp_height = *((unsigned int*)(bmpdata+0x16)); 
	
	printf("Width is %u\n", bmp_width);
	printf("Height is %u\n", bmp_height);
	
	assert(bmp_width % 16 == 0); //Sprites are 16px wide
	
	unsigned int bmp_colors = *((unsigned int*)(bmpdata+0x2E)); 
	assert(bmp_colors > 16 && bmp_colors <= 256);
		
	int stripe;
	for(stripe = 0; stripe < bmp_width/16; stripe++)
	{
		int r;
		for(r = 0; r < bmp_height; r++)
		{
			fwrite(bmpdata+pixel_offset+(bmp_width*(bmp_height-(r+1)))+(stripe*16), 1, 16, pxfile);

			//Pack alpha bits
			/*unsigned short alpha_packed = 0;
			int p;
			for(p=0;p<16;p++)
			{
				alpha_packed <<= 1;

				if(*(unsigned char*)(bmpdata+pixel_offset+(bmp_width*(bmp_height-(r+1)))+(stripe*16)+p) != 0)
					alpha_packed |= 1;
			}

			fwrite(&alpha_packed, 1, 2, afile);*/
		}
	}

	free(bmpdata);
	
	fclose(pxfile);
	fclose(bmpfile);
//	fclose(afile);
	
	return 0;
}
