//paller.c
//Converts GIMP palette to raw colors
//Bryan Topp <betopp@betopp.com> 2015

#include <stdio.h>
#include <assert.h>
#include <stdlib.h>

int main(int argc, const char **argv)
{
	if(argc != 3)
	{
		printf("usage: %s <GIMP palette> <raw output>\n", argv[0]);
		exit(-1);
	}
	
	FILE *infile = fopen(argv[1], "r");
	assert(infile);
	
	FILE *outfile = fopen(argv[2], "wb");
	assert(outfile);
	
	//Advance past header.
	char linebuf[256]; linebuf[0] = '\0'; linebuf[255] = '\0';
	while(linebuf[0] != '#')
	{
		if(fgets(linebuf, 255, infile) == NULL)
			break;
	}
	
	assert(linebuf[0] == '#');
	
	int p_read;
	for(p_read = 0; p_read < 256; p_read++)
	{
		unsigned int r, g, b, z;
		z = 0;
		
		if(fgets(linebuf, 255, infile) == NULL)
			break;
		
		if(sscanf(linebuf, " %d %d %d ", &r, &g, &b) != 3)
			break;
		
		unsigned char rc = r;
		unsigned char gc = g;
		unsigned char bc = b;
		unsigned char zc = z;
		
		//printf("%d %d %d\n", r, g, b);
		
		fwrite(&bc, 1, 1, outfile);
		fwrite(&gc, 1, 1, outfile);
		fwrite(&rc, 1, 1, outfile);
		fwrite(&zc, 1, 1, outfile);
	}
	printf("wrote %d actual palette entries\n", p_read);
	
	while(p_read < 256)
	{
		unsigned char rc = 0;
		unsigned char gc = 0;
		unsigned char bc = 0;
		unsigned char zc = 0;
		
		if(p_read % 2)
		{
			rc = 255;
			gc = 255;
			bc = 255;
		}
		
		fwrite(&bc, 1, 1, outfile);
		fwrite(&gc, 1, 1, outfile);
		fwrite(&rc, 1, 1, outfile);
		fwrite(&zc, 1, 1, outfile);
		
		p_read++;
		
	}
	
	return 0;
}