//padpush.c
//Dev tool: grabs keyboard state with SDL and builds bytes for our fake pads method
//Acts as pads for Blackfin when we don't actually have it working

#include <stdio.h>
#include <SDL2/SDL.h>
#include <assert.h>

#define PADS_BIT_LEFT 0x01
#define PADS_BIT_RIGHT 0x02
#define PADS_BIT_UP 0x04
#define PADS_BIT_DOWN 0x08
#define PADS_BIT_B1 0x10
#define PADS_BIT_B2 0x20
#define PADS_BIT_B3 0x40
#define PADS_BIT_START 0x80

int echothread(void *data)
{
	FILE *echof = fopen("/dev/ttyUSB0", "r");
	assert(echof);
	
	char echobuffer[1024];
	
	while(1)
	{
		memset(echobuffer, 0, sizeof(echobuffer));
		fflush(echof);
		fgets(echobuffer, 1023, echof);
		fputs(echobuffer, stdout);
	}
	
}


int main(int argc, const char **argv)
{
	//Spin off a thread to echo Blackfin's stdout
	if(SDL_CreateThread(echothread, "echo thread", NULL) == NULL)
	{
		printf("error making echo thread\n");
		exit(-1);
	}
	
	FILE *outf = fopen("/dev/ttyUSB0", "wb");
	assert(outf);
	
	SDL_Window *sdlWin;
	SDL_Renderer *sdlRen;	
	
	SDL_Init(SDL_INIT_VIDEO);
	int err = SDL_CreateWindowAndRenderer(128, 128, /*flags*/ 0, &sdlWin, &sdlRen);
	assert(!err);
	assert(sdlWin);
	assert(sdlRen);
	
	while(1)
	{
		//Pump events and vsync
		SDL_RenderClear(sdlRen);
		SDL_RenderPresent(sdlRen);
		
		SDL_Event e;
		while(SDL_PollEvent(&e))
		{
			if(e.type == SDL_QUIT)
				exit(0);
		}
		
		
		//Read control data and send it out the serial port
		unsigned char pads_firstplayer;
		const unsigned char *keystates = SDL_GetKeyboardState(NULL);
	
		pads_firstplayer = 0;
		if(keystates[SDL_SCANCODE_LEFT])
			pads_firstplayer |= PADS_BIT_LEFT;
		if(keystates[SDL_SCANCODE_RIGHT])
			pads_firstplayer |= PADS_BIT_RIGHT;
		if(keystates[SDL_SCANCODE_UP])
			pads_firstplayer |= PADS_BIT_UP;
		if(keystates[SDL_SCANCODE_DOWN])
			pads_firstplayer |= PADS_BIT_DOWN;

		if(keystates[SDL_SCANCODE_LCTRL])
			pads_firstplayer |= PADS_BIT_B1;
		if(keystates[SDL_SCANCODE_LALT])
			pads_firstplayer |= PADS_BIT_B2;
		if(keystates[SDL_SCANCODE_SPACE])
			pads_firstplayer |= PADS_BIT_B3;
		if(keystates[SDL_SCANCODE_1])
			pads_firstplayer |= PADS_BIT_START;
		
		fwrite(&pads_firstplayer, 1, 1, outf);
		fflush(outf);
	}
	
	fclose(outf);
}
