//pads.h
//Handles communication with the IO controller
//Bryan Topp <betopp@betopp.com> 2015

//Initializes the input system.
void pads_init();

//Starts grabbing new inputs from the pads (ignored if we're already polling)
void pads_poll();

//Returns how many credits are present for P1/P2
unsigned char pads_get_p1_credits();
unsigned char pads_get_p2_credits();

//Attempts to decrement the credit count and start the game - returns nonzero if credits deducted
unsigned char pads_deduct_p1_credit();
unsigned char pads_deduct_p2_credit();

//Returns non-zero if the pads system is OK; returns 0 if init failed
unsigned char pads_isvalid();

//The following definitions should match those in the IO controller.

//Joystick bits
#define PADS_BIT_LEFT 0x01
#define PADS_BIT_RIGHT 0x02
#define PADS_BIT_UP 0x04
#define PADS_BIT_DOWN 0x08

//Button bits
#define PADS_BIT_B1 0x10
#define PADS_BIT_B2 0x20
#define PADS_BIT_B3 0x40
#define PADS_BIT_START 0x80
extern unsigned char pads_firstplayer;
extern unsigned char pads_secondplayer;

#define PADS_SYS_BIT_COIN1 0x01 //DON'T ACTUALLY USE THIS DIRECTLY! Query IOCON for bookkeeping.
#define PADS_SYS_BIT_COIN2 0x02 //DON'T ACTUALLY USE THIS DIRECTLY! Query IOCON for bookkeeping.
#define PADS_SYS_BIT_SERVICE 0x04
#define PADS_SYS_BIT_TEST 0x08
extern unsigned char pads_sysbuttons;