//shooty_fx.h
//FX for shooty game
//Bryan Topp <betopp@betopp.com> 2016

#pragma once

#include "shooty_common.h"

//Intializes FX for a new stage
void shooty_fx_initstage(unsigned char stagenum);

//Spawns an FX at the given position with the given type.
void shooty_fx_spawn(short x, short y, unsigned char fxtype);

//Helper function; spawns the best FX for a given point value
void shooty_fx_spawn_points_helper(short x, short y, unsigned short pointvalue);

//Updates/ticks the FX which are currently active
void shooty_fx_update();

//Pushes data from the just-computed FX into the sprite table
void shooty_fx_fillsprites();

enum ShootyFxType
{
	FXTYPE_DEATH = 0,
	FXTYPE_HIT,
	FXTYPE_FLOATER,
	
	FXTYPE_POINTS_000,
	FXTYPE_POINTS_100,
	FXTYPE_POINTS_200,
	FXTYPE_POINTS_300,
	FXTYPE_POINTS_400,
	FXTYPE_POINTS_500,
	FXTYPE_POINTS_600,
	FXTYPE_POINTS_700,
	FXTYPE_POINTS_800,
	FXTYPE_POINTS_900,
	
	FXTYPE_MAX
};
	