//shooty_player.h
//Player ships, lives, scoring
//Bryan Topp <betopp@betopp.com> 2016

#pragma once

#include "shooty_common.h"

//Init for new stage
void shooty_players_initstage(unsigned char level);

//Update/tick function
void shooty_players_update();

//Fills sprite table with new data
void shooty_players_fillsprites();

//Awards points (caller needs to play the effect though)
void shooty_players_awardpts(unsigned char which, unsigned short amt);

//Gives lives (e.g. pressing start)
void shooty_players_awardlives(unsigned char which, unsigned char amt);

//Normally the player proceeds through these in-order.
//They aren't allowed to leave the init state if they have 0 lives.
//Leaving init will deduct from their lives counter.
#define PLAYER_STATE_INIT 0
#define PLAYER_STATE_SPAWNING 1
#define PLAYER_STATE_INVULNERABLE 2
#define PLAYER_STATE_NORMAL 3
#define PLAYER_STATE_EXPLODING 4
#define PLAYER_STATE_DEAD 5
#define PLAYER_STATE_TYPING 6

typedef struct playerstate_s {
	unsigned char extralives; //How many times the player will be spawned after now
	unsigned char state; //The state they are in (See above)
	unsigned int stateframe; //How long they've been in the state
	unsigned int score; //Their total score
	short pos_x; //Their horizontal position (left)
	short pos_y; //Their vertical position (top)
	unsigned char shotqueue; //How many shots they are going to fire
	unsigned char shotcooldown; //How soon can they fire their next shot
	unsigned char holdingshoot; //How long they were holding the fire button
	
	//For typing high score name
	unsigned char namebuffer[3];
	unsigned char namepos; 
	unsigned char namedebounce; 
} playerstate_t;

extern playerstate_t players[2];


typedef struct playerbullet_s {
	short pos_x;
	short pos_y;
} playerbullet_t;

extern playerbullet_t playerbullets[2][BULLET_MAX];
